#!/usr/bin/env python
#
# $Id: DarcReport.py 38 2006-04-09 21:18:40Z jacob $
# 
# Jacob Martinson <martinson.jacob at gmail.com>
#
# This software is licensed under the Gnu Public License
# For more info see: 
#         http://www.gnu.org/licenses/gpl.html


class DarcReport:

	def __init__(self,host_list):
		self.host_list = host_list
		self.set_std_vars()
		self.report = ''

	def gen_report(self):
		return 'gen_report() method not implemented, need to override in a subclass.'

	def set_std_vars(self):

		total_c = 0
		init_c = 0
		fail_c = 0
		pass_c = 0
		prob_c = 0

		fail_list = []
		init_list = []
		pass_list = []
		prob_list = []
	
		for h in self.host_list:
	
			total_c += 1

			if h.status   == 'FAIL':
				fail_c += 1
				fail_list.append(h)
	
			elif h.status == 'PASS':
				pass_c += 1
				pass_list.append(h)
	
			elif h.status == 'PROB':
				prob_c += 1
				prob_list.append(h)

			elif h.status == 'INIT':
				init_c += 1
				init_list.append(h)

		self.total_c = total_c

		self.init_c = init_c
		self.fail_c = fail_c
		self.pass_c = pass_c
		self.prob_c = prob_c

		self.fail_list = fail_list
		self.init_list = init_list
		self.pass_list = pass_list
		self.prob_list = prob_list


