from DarcReport import DarcReport

class TextReport(DarcReport):

	def gen_report(self):
		r = self.get_head()
		r += self.get_host_lists()
		r += self.get_full_host_reports()
		r += self.get_problem_logs()
		return r

	def get_head(self):
		tmpl = '''
DARC AIDE Report 

+----------------------------------------------------------------------------
| Summary:
+----------------------------------------------------------------------------
%(numhosts)4d hosts listed for monitoring

%(numinit)4d hosts were initialized
%(numfail)4d hosts failed with file modifications
%(numpass)4d hosts passed without file modifications
%(numprob)4d hosts were unable to be checked

''' % { 'numhosts': self.total_c, 
        'numinit': self.init_c, 
        'numfail': self.fail_c, 
        'numpass': self.pass_c, 
		'numprob': self.prob_c }

		return tmpl



	def get_host_lists(self):

		# failed host list section
		if len(self.fail_list) == 0:
			fail_text = ''
		else:
			fail_text = '''
+----------------------------------------------------------------------------
| Failed Host List:
+----------------------------------------------------------------------------
'''
		
		for x in self.fail_list:
			fail_text +=  '%s\n' % x.hostname

		# problem checking section
		if len(self.prob_list) == 0:
			prob_text = ''
		else:
			prob_text = '''

+----------------------------------------------------------------------------
| Unchecked Host List:
+----------------------------------------------------------------------------
'''

		for x in self.prob_list:
			prob_text +=  '%s\n' % x.hostname

		return fail_text + prob_text
	


	def get_full_host_reports(self):
		
		if len(self.fail_list) == 0:
			return ''
		else:
			text = '''

+----------------------------------------------------------------------------
| Detailed AIDE Reports
+----------------------------------------------------------------------------

'''
		for x in self.fail_list:
			text += '''
+----------------------------------------------------------------------------
%s:
''' % x.hostname

			rep_fh = open(x.report,'r')
			ln = rep_fh.readline()
			while ln:
				text += '      ' + ln
				ln = rep_fh.readline()
			rep_fh.close()

		return text


	def get_problem_logs(self):

		if len(self.prob_list) == 0:
			return ''
		else:
			text = '''

+----------------------------------------------------------------------------
| Unchecked Host Problem Details:
+----------------------------------------------------------------------------

'''
		for x in self.prob_list:
			text += '-------------------------------------------------------\n'
			text += '%s:\n' % x.hostname
			for ln in x.status_detail:
				text +=  str(ln) + '\n'
			text += '\n\n'

		return text

